Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam.F90	(revision 2587)
@@ -28,4 +28,5 @@
    USE phycst          ! physical constant                  (par_cst routine)
    USE tamtrj          ! handling of the trajectory
+   USE trj_tam         ! handling of the trajectory
    USE tamctl          ! Control parameters
    USE oce_tam         ! TL and adjoint data
@@ -33,5 +34,5 @@
    USE trc_oce_tam     ! Trend tangent and adjoint arrays
    USE sol_oce_tam     ! Solver tangent and adjoint arrays
-   USE tamtst          ! Gradient testing
+   USE tamtst
    ! ocean physics
 #if defined key_tam
@@ -41,4 +42,5 @@
    USE zdfini 
 
+#if defined key_tst_tlm
 #if defined key_tam
    USE opatam_tst_ini, ONLY :  &
@@ -47,4 +49,5 @@
      & opatam_4_tst_ini
 #endif
+#endif
 
    IMPLICIT NONE
@@ -109,5 +112,5 @@
       !! * Local declarations
       CHARACTER (len=128) :: file_out = 'nemovar.output'
-      CHARACTER (len=*), PARAMETER  ::  namelistname = 'namelist.nemovar' 
+      CHARACTER (len=*), PARAMETER  ::  namelistname = 'namelist.nemotam' 
       NAMELIST/namctl/ ln_ctl, nprint, nictls, nictle,   &
          &             isplt , jsplt , njctls, njctle, nbench, nbit_cmp
@@ -127,7 +130,8 @@
 
       ! Nodes selection
-      narea = mynode()
-      narea = narea + 1    ! mynode return the rank of proc (0 --> jpnij -1 )
+      nproc = mynode()
+      narea = nproc + 1    ! mynode return the rank of proc (0 --> jpnij -1 )
       lwp   = narea == 1
+      ln_rstart = .FALSE.
 
       ! open additionnal listing
@@ -185,4 +189,5 @@
       CALL     tam_trj_ini
 
+      CALL day_init
       CALL day( nit000 )
 
@@ -204,7 +209,6 @@
 
       !! * Local declarations
-      NAMELIST/namtst/ ln_tst, ln_tst_bkgadj, ln_tst_obsadj, ln_tst_nemotam, &
-         &             ln_tst_grad, ln_tst_cpd_tam, ln_tst_stp_tam, &
-         &             ln_tst_tan_cpd, ln_tst_tan
+      NAMELIST/namtst/ ln_tst_nemotam, ln_tst_cpd_tam, ln_tst_stp_tam, &
+         &             ln_tst_tan_cpd, ln_tst_tan, ln_tst_stop
 
       REAL(wp) :: &
@@ -241,13 +245,10 @@
       i_flag_rc = 0
 
-      ln_tst         = .TRUE.
-      ln_tst_obsadj  = .FALSE.
-      ln_tst_bkgadj  = .FALSE.
       ln_tst_nemotam = .FALSE.
-      ln_tst_grad    = .FALSE.
       ln_tst_cpd_tam = .FALSE.
       ln_tst_stp_tam = .FALSE.
       ln_tst_tan_cpd = .FALSE.
       ln_tst_tan     = .FALSE.
+      ln_tst_stop    = .FALSE.
 
       REWIND( numnam )
@@ -258,9 +259,6 @@
          WRITE(numout,*) ' namtst'
          WRITE(numout,*) ' '
-         WRITE(numout,*) ' master switch for operator tests     ln_tst = ',ln_tst
-         WRITE(numout,*) ' switch for H adjoint tests    ln_tst_obsadj = ',ln_tst_obsadj
-         WRITE(numout,*) ' switch for B adjoint tests    ln_tst_bkgadj = ',ln_tst_bkgadj
          WRITE(numout,*) ' switch for M adjoint tests   ln_tst_nemotam = ',ln_tst_nemotam
-         WRITE(numout,*) ' switch for gradient test        ln_tst_grad = ',ln_tst_grad
+         WRITE(numout,*) ' stop after tests                ln_tst_stop = ',ln_tst_stop
          WRITE(numout,*) ' '
 
@@ -269,5 +267,5 @@
       ! B.4 Tests
 
-      IF ( ln_tst ) CALL tstopt
+      IF ( ln_tst_nemotam ) CALL tsttam
 
    END SUBROUTINE nemotam_sub
@@ -296,4 +294,13 @@
       IF ( lk_mpp ) CALL mppsync
 
+      ! Deallocate variables
+      ! --------------------
+      CALL oce_tam_deallocate ( 0 )
+      CALL sol_oce_tam_deallocate ( 0 )
+#if defined key_tam
+      CALL sbc_oce_tam_deallocate ( 0 )
+      CALL trc_oce_tam_deallocate ( 0 )
+#endif
+      CALL trj_deallocate
       ! Unit close
       ! ----------
@@ -301,5 +308,5 @@
       CLOSE( numnam )       ! namelist
       CLOSE( numout )       ! standard model output file
-      IF ( .NOT. lini ) THEN
+      IF (  lini ) THEN
          CLOSE( numtan_sc )    ! tangent test diagnostic output
          CLOSE( numtan )       ! tangent diagnostic output
@@ -349,19 +356,15 @@
       !!----------------------------------------------------------------------
       !! * Local declarations
-      NAMELIST/namtst/ ln_tst, ln_tst_bkgadj, ln_tst_obsadj, ln_tst_nemotam, &
-         &             ln_tst_grad, ln_tst_cpd_tam, ln_tst_stp_tam, &
-         &             ln_tst_tan_cpd, ln_tst_tan
+      NAMELIST/namtst/ ln_tst_nemotam, ln_tst_cpd_tam, ln_tst_stp_tam, &
+         &             ln_tst_tan_cpd, ln_tst_tan, ln_tst_stop
       CHARACTER (len=*), PARAMETER  ::  namelistname = 'namelist.nemotam'
       !! * Arguments
 
-      ln_tst         = .TRUE.
-      ln_tst_obsadj  = .FALSE.
-      ln_tst_bkgadj  = .FALSE.
       ln_tst_nemotam = .FALSE.
-      ln_tst_grad    = .FALSE.
       ln_tst_cpd_tam = .FALSE.
       ln_tst_stp_tam = .FALSE.
       ln_tst_tan_cpd = .FALSE.
       ln_tst_tan     = .FALSE.
+      ln_tst_stop    = .TRUE.
 
       CALL ctlopn( numnam, namelistname, 'OLD', 'FORMATTED', 'SEQUENTIAL',   &
@@ -372,6 +375,10 @@
 
       IF ( ln_tst_tan ) THEN
+#if defined key_tst_tlm
          CALL  opa_opatam_ini
          lini = .FALSE.            ! not standard initialisation
+#else
+         CALL ctl_stop( 'Activate key_tst_tlm for ln_tst_tan=.true.' )
+#endif
       ELSE
          CALL nemotam_init
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam_hlt.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam_hlt.F90	(revision 2587)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/nemotam_hlt.F90	(revision 2587)
@@ -0,0 +1,123 @@
+MODULE nemotam_hlt
+#if defined key_tam
+   !!==========================================================================
+   !!                       ***  MODULE nemotam ***
+   !! NEMOTAM system : Tangent and Adjoint for NEMO.
+   !!==========================================================================
+
+   !!----------------------------------------------------------------------
+   !!   nemotam_main   : Main driver routine for NEMOTAM
+   !!   nemotam_init   : Initialization of NEMOTAM
+   !!   nemotam_final  : Finish up NEMOTAM
+   !!----------------------------------------------------------------------
+   !! History :
+   !!   1.0  !  07-06  (K. Mogensen) Initial version
+   !!        !  09-06  (F. Vigilant)  Modified to split NEMOVAR / NEMOTAM
+   !!                                     module tamctl     i/o varctl
+   !!---------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! * Modules used
+   USE hlttst          ! testing routine of linear-tangent hypothesis
+   USE par_tlm
+   USE in_out_manager  ! I/O manager
+
+   IMPLICIT NONE
+   PRIVATE
+
+   !! * Module variables
+
+   !! * Routine accessibility
+
+   PUBLIC &
+      & nemotam_hlt_main  
+
+CONTAINS
+
+   SUBROUTINE nemotam_hlt_main 
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE nemotam_main  ***
+      !!          
+      !! ** Purpose : Main driver routine for NEMOTAM
+      !!
+      !! ** Method  : Nothing yet
+      !!
+      !! ** Action  : Nothing yet
+      !!
+      !! History :
+      !!        !  07-06  (K. Mogensen) Original code
+      !!----------------------------------------------------------------------
+
+      !! * Local declarations
+
+      ! Read namelist for model  
+      CALL hlt_root
+
+      ! Main tst
+      CALL hlt_tst
+
+   END SUBROUTINE nemotam_hlt_main
+
+   SUBROUTINE hlt_root
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE nemovar_root ***
+      !!          
+      !! ** Purpose : Choose which init must be done according to test
+      !!
+      !! ** Method  : Read namelist
+      !!
+      !! ** Action  : 
+      !!
+      !! History :
+      !!        !  10-07  (F. Vigilant) Original code
+      !!----------------------------------------------------------------------
+      !! * Modules used
+      USE par_tlm
+!      USE in_out_manager, ONLY: & ! I/O manager
+!      & numnam, numout
+      !! * Arguments
+
+      !! * Local declarations
+      NAMELIST/namhlt/ nstg, ln_hltt, ln_hlts, ln_hltuv, ln_hltssh, c_hltinc, &
+                     & ln_incdx, ln_hnorm, rhstdt, rhstds, rhstduv, rhstdssh 
+
+      CHARACTER (len=20) ::  namelistname = 'namelist.hlt'
+      CHARACTER (len=28) ::  file_out
+      !! * Arguments
+
+      nstg = 0
+      ln_hltt   = .FALSE.
+      ln_hlts   = .FALSE.
+      ln_hltuv  = .FALSE.
+      ln_hltssh = .FALSE.
+      c_hltinc  = ''
+      ln_incdx  = .FALSE.
+      ln_hnorm  = .FALSE.
+      rhstdt    = 1.0_wp
+      rhstds    = 0.1_wp
+      rhstduv   = 0.01_wp
+      rhstdssh  = 0.01_wp
+
+      file_out = 'nemohlt.output'
+     
+      ! open listing and namelist units
+      CALL ctlopn( numout, file_out, 'UNKNOWN', 'FORMATTED',   &
+         &         'SEQUENTIAL', 1, 6, .FALSE., 1 )
+
+      WRITE(numout,*)
+      WRITE(numout,*) '                 L O D Y C - I P S L'
+      WRITE(numout,*) '                     O P A model'
+      WRITE(numout,*) '            Ocean General Circulation Model'
+      WRITE(numout,*) '               version OPA 9.0  (2005) '
+      WRITE(numout,*)
+      WRITE(numout,*)
+      call flush(numout)
+
+      CALL ctlopn( numnam,namelistname, 'OLD', 'FORMATTED', 'SEQUENTIAL',   &
+         &           1, numout, .FALSE., 1 )
+
+      REWIND( numnam )
+      READ  ( numnam, namhlt )
+
+   END SUBROUTINE hlt_root
+#endif 
+END MODULE nemotam_hlt
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/oce_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/oce_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/oce_tam.F90	(revision 2587)
@@ -34,4 +34,5 @@
    PUBLIC &
       & oce_tam_init, & !: Initialize the TAM fields
+      & oce_tam_deallocate, &
                     !:
       & ub_tl,    & !: Tangent linear of before u-component velocity
@@ -788,4 +789,222 @@
 
    END SUBROUTINE oce_tam_init
+   SUBROUTINE oce_tam_deallocate ( kindic )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE oce_tam_deallocate  ***
+      !!
+      !! ** Purpose : Deallocate the tangent linear and 
+      !!              adjoint arrays
+      !!
+      !! ** Method  : kindic = 0  deallocate both tl and ad variables
+      !!              kindic = 1  deallocate only tl variables
+      !!              kindic = 2  deallocate only ad variables
+      !!
+      !! ** Action  :
+      !!                   
+      !! References : 
+      !!
+      !! History :
+      !!        ! 2010-06 (A. Vidard) initial version
+      !!-----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kindic        ! indicate which variables to allocate/initialize
+      
+      !! * Local declarations
+      ! Dellocate tangent linear variable arrays
+      ! ---------------------------------------
+      
+      IF ( kindic == 0 .OR. kindic == 1 ) THEN
+
+         IF ( ALLOCATED(ub_tl) ) DEALLOCATE( ub_tl )
+
+         IF ( ALLOCATED(un_tl) ) DEALLOCATE( un_tl )
+
+         IF ( ALLOCATED(ua_tl) ) DEALLOCATE( ua_tl )
+
+         IF ( ALLOCATED(vb_tl) ) DEALLOCATE( vb_tl )
+
+         IF ( ALLOCATED(vn_tl) ) DEALLOCATE( vn_tl )
+
+         IF ( ALLOCATED(va_tl) ) DEALLOCATE( va_tl )
+
+         IF ( ALLOCATED(wn_tl) ) DEALLOCATE( wn_tl )
+
+         IF ( ALLOCATED(rotb_tl) ) DEALLOCATE( rotb_tl )
+            
+         IF ( ALLOCATED(rotn_tl) ) DEALLOCATE( rotn_tl )
+            
+         IF ( ALLOCATED(hdivb_tl) ) DEALLOCATE( hdivb_tl )
+
+         IF ( ALLOCATED(hdivn_tl) ) DEALLOCATE( hdivn_tl )
+            
+         IF ( ALLOCATED(tb_tl) ) DEALLOCATE( tb_tl )
+            
+         IF ( ALLOCATED(tn_tl) ) DEALLOCATE( tn_tl )
+
+         IF ( ALLOCATED(ta_tl) ) DEALLOCATE( ta_tl )
+            
+         IF ( ALLOCATED(sb_tl) ) DEALLOCATE( sb_tl )
+
+         IF ( ALLOCATED(sn_tl) ) DEALLOCATE( sn_tl )
+
+         IF ( ALLOCATED(sa_tl) ) DEALLOCATE( sa_tl )
+            
+         IF ( ALLOCATED(rhd_tl) ) DEALLOCATE( rhd_tl )
+            
+         IF ( ALLOCATED(rhop_tl) ) DEALLOCATE( rhop_tl )
+
+         IF ( ALLOCATED(rn2_tl) ) DEALLOCATE( rn2_tl )
+
+         IF ( ALLOCATED(spgu_tl) ) DEALLOCATE( spgu_tl )
+            
+         IF ( ALLOCATED(spgv_tl) ) DEALLOCATE( spgv_tl )
+            
+#if defined key_dynspg_rl
+         IF ( ALLOCATED(bsfb_tl) ) DEALLOCATE( bsfb_tl )
+         
+         IF ( ALLOCATED(bsfn_tl) ) DEALLOCATE( bsfn_tl )
+         
+         IF ( ALLOCATED(bsfd_tl) ) DEALLOCATE( bsfd_tl )
+         
+#else
+         IF (ALLOCATED(sshb_tl) ) DEALLOCATE( sshb_tl )
+
+         IF (ALLOCATED(sshn_tl) ) DEALLOCATE( sshn_tl )
+
+         IF (ALLOCATED(ssha_tl) ) DEALLOCATE( ssha_tl )
+
+         IF (ALLOCATED(sshu_tl) ) DEALLOCATE( sshu_tl )
+
+         IF (ALLOCATED(sshv_tl) ) DEALLOCATE( sshv_tl )
+
+         IF (ALLOCATED(sshbb_tl) ) DEALLOCATE( sshbb_tl )
+
+#endif      
+         IF ( ALLOCATED(gtu_tl) ) DEALLOCATE( gtu_tl )
+
+         IF ( ALLOCATED(gtv_tl) ) DEALLOCATE( gtv_tl )
+
+         IF ( ALLOCATED(gsu_tl) ) DEALLOCATE( gsu_tl )
+
+         IF ( ALLOCATED(gsv_tl) ) DEALLOCATE( gsv_tl )
+
+         IF ( ALLOCATED(gru_tl) ) DEALLOCATE( gru_tl )
+
+         IF ( ALLOCATED(grv_tl) ) DEALLOCATE( grv_tl )
+
+
+
+#if defined key_zdfddm
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!  AW: The declaration/allocation/initialization of these variables
+!!!!      should be moved to a new module zdf_ddm_tam_init to be consistent
+!!!!      with NEMO.
+         IF ( ALLOCATED(rrau_tl) ) DEALLOCATE( rrau_tl )
+            
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+#endif
+
+
+      ENDIF
+
+      IF ( kindic == 0 .OR. kindic == 2 ) THEN
+
+         ! Allocate adjoint variable arrays
+         ! --------------------------------
+      
+         IF ( ALLOCATED(ub_ad) ) DEALLOCATE( ub_ad )
+
+         IF ( ALLOCATED(un_ad) ) DEALLOCATE( un_ad )
+
+         IF ( ALLOCATED(ua_ad) ) DEALLOCATE( ua_ad )
+
+         IF ( ALLOCATED(vb_ad) ) DEALLOCATE( vb_ad )
+
+         IF ( ALLOCATED(vn_ad) ) DEALLOCATE( vn_ad )
+
+         IF ( ALLOCATED(va_ad) ) DEALLOCATE( va_ad )
+
+         IF ( ALLOCATED(wn_ad) ) DEALLOCATE( wn_ad )
+            
+         IF ( ALLOCATED(rotb_ad) ) DEALLOCATE( rotb_ad )
+
+         IF ( ALLOCATED(rotn_ad) ) DEALLOCATE( rotn_ad )
+
+         IF ( ALLOCATED(hdivb_ad) ) DEALLOCATE( hdivb_ad )
+
+         IF ( ALLOCATED(hdivn_ad) ) DEALLOCATE( hdivn_ad )
+
+         IF ( ALLOCATED(tb_ad) ) DEALLOCATE( tb_ad )
+            
+         IF ( ALLOCATED(tn_ad) ) DEALLOCATE( tn_ad )
+
+         IF ( ALLOCATED(ta_ad) ) DEALLOCATE( ta_ad )
+
+         IF ( ALLOCATED(sb_ad) ) DEALLOCATE( sb_ad )
+            
+         IF ( ALLOCATED(sn_ad) ) DEALLOCATE( sn_ad )
+            
+         IF ( ALLOCATED(sa_ad) ) DEALLOCATE( sa_ad )
+            
+         IF ( ALLOCATED(rhd_ad) ) DEALLOCATE( rhd_ad )
+            
+         IF ( ALLOCATED(rhop_ad) ) DEALLOCATE( rhop_ad )
+            
+         IF ( ALLOCATED(rn2_ad) ) DEALLOCATE( rn2_ad )
+
+         IF ( ALLOCATED(spgu_ad) ) DEALLOCATE( spgu_ad )
+
+         IF ( ALLOCATED(spgv_ad) ) DEALLOCATE( spgv_ad )
+
+#if defined key_dynspg_rl
+         IF ( ALLOCATED(bsfb_ad) ) DEALLOCATE( bsfb_ad )
+         
+         IF ( ALLOCATED(bsfn_ad) ) DEALLOCATE( bsfn_ad )
+
+         IF ( ALLOCATED(bsfd_ad) ) DEALLOCATE( bsfd_ad )
+
+#else
+         IF ( ALLOCATED(sshb_ad) ) DEALLOCATE( sshb_ad )
+
+         IF ( ALLOCATED(sshn_ad) ) DEALLOCATE( sshn_ad )
+
+         IF ( ALLOCATED(ssha_ad) ) DEALLOCATE( ssha_ad )
+
+         IF ( ALLOCATED(sshu_ad) ) DEALLOCATE( sshu_ad )
+
+         IF ( ALLOCATED(sshv_ad) ) DEALLOCATE( sshv_ad )
+
+         IF ( ALLOCATED(sshbb_ad) ) DEALLOCATE( sshbb_ad )
+
+#endif      
+         IF ( ALLOCATED(gtu_ad) ) DEALLOCATE( gtu_ad )
+
+         IF ( ALLOCATED(gtv_ad) ) DEALLOCATE( gtv_ad )
+
+         IF ( ALLOCATED(gsu_ad) ) DEALLOCATE( gsu_ad )
+
+         IF ( ALLOCATED(gsv_ad) ) DEALLOCATE( gsv_ad )
+
+         IF ( ALLOCATED(gru_ad) ) DEALLOCATE( gru_ad )
+
+         IF ( ALLOCATED(grv_ad) ) DEALLOCATE( grv_ad )
+
+
+
+#if defined key_zdfddm
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!  AW: The declaration/allocation/initialization of these variables
+!!!!      should be moved to a new module zdf_ddm_tam_init to be consistent
+!!!!      with NEMO.
+         IF ( ALLOCATED(rrau_ad) ) DEALLOCATE( rrau_ad )
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+#endif
+
+      ENDIF
+
+   END SUBROUTINE oce_tam_deallocate
       
 END MODULE oce_tam
